Jenkins Slave Setup

If you have extra machines, we welcome you to set them up as Jenkins slaves for SOLVCON. The first step is to contact the site admin to set up a node for you. Then, you can configure your machines as headless slaves. If you are running Debian or Ubuntu, we’ve prepared the configuration scripts for you: (i) the init script file /etc/init.d/jenkins-slave and (ii) the default file /etc/default/jenkins-slave. To run the slave, you need at least two prerequisite packages and they can be installed by:

$ apt-get install daemon sun-java6-jre

Before starting the slave, don’t forget to supply the settings JENKINS_SLAVE_USER and JENKINS_SLAVE_HOME in the default file /etc/default/jenkins-slave.

If everything runs correctly, then you can install the init script to rc.d:

$ update-rc.d jenkins-slave defaults

so that the slave can automatically run on machine start-up.

In the directory contrib/ of the source package of SOLVCON, /etc/init.d/jenkins-slave, /etc/default/jenkins-slave, and a install script that does the above actions are supplied for your convenience.

File Listings

/etc/init.d/jenkins-slave

#! /bin/sh
### BEGIN INIT INFO
# Provides:          jenkins-slave
# Required-Start:    $remote_fs $syslog
# Required-Stop:     $remote_fs $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Example initscript
# Description:       This file should be used to construct scripts to be
#                    placed in /etc/init.d.
### END INIT INFO

# Author: Yung-Yu Chen <yyc@solvcon.net>
#
# Please remove the "Author" lines above and replace them
# with your own name if you copy and modify this script.

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="jenkins slave"
NAME=jenkins-slave
#DAEMON=/usr/bin/java
DAEMON=/usr/bin/daemon
SCRIPTNAME=/etc/init.d/$NAME

WGET=wget
SU=/bin/su

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions

PIDFILE=$JENKINS_SLAVE_ROOT/$NAME.pid
DAEMON_ARGS="--user=$JENKINS_SLAVE_USER --output=$JENKINS_SLAVE_LOG "\
"--pidfile=$PIDFILE --command=java -- "\
"-jar $JENKINS_SLAVE_JAR -jnlpUrl $JENKINS_NODE_URL"

#
# Function that starts the daemon/service
#
do_start()
{
	# Return
	#   0 if daemon has been started
	#   1 if daemon was already running
	#   2 if daemon could not be started
	[ "$JENKINS_SLAVE_USER" = "" ] && return 2
	[ "$JENKINS_SLAVE_HOME" = "" ] && return 2
	start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
		|| return 1
	mkdir $JENKINS_SLAVE_ROOT > /dev/null 2>&1 || true
	chown $JENKINS_SLAVE_USER $JENKINS_SLAVE_ROOT
	cd $JENKINS_SLAVE_ROOT
	$SU -l $JENKINS_SLAVE_USER -c \
		"wget -q -r $JENKINS_SLAVE_JAR_URL -O $JENKINS_SLAVE_JAR"
	# XXX: a hack to make ssh key-auth work for solvcon.helper.get_username().
	export LOGNAME=$JENKINS_SLAVE_USER
	# XXX: similar to the hack, but not of real use.
	export USER=$JENKINS_SLAVE_USER
	export USERNAME=$JENKINS_SLAVE_USER
	export HOME=$JENKINS_SLAVE_HOME
	start-stop-daemon --start --pidfile $PIDFILE --exec $DAEMON \
		-- $DAEMON_ARGS || return 2
}

#
# Function that stops the daemon/service
#
do_stop()
{
	# Return
	#   0 if daemon has been stopped
	#   1 if daemon was already stopped
	#   2 if daemon could not be stopped
	#   other if a failure occurred
	#start-stop-daemon --stop --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
	RETVAL="$?"
	#[ "$RETVAL" = 2 ] && return 2
	# Wait for children to finish too if this is a daemon that forks
	# and if the daemon is only ever run from this initscript.
	# If the above conditions are not satisfied then add some other code
	# that waits for the process to drop all resources that could be
	# needed by services started subsequently.  A last resort is to
	# sleep for some time.
	start-stop-daemon --stop --oknodo --retry=TERM/30/KILL/5 --exec $DAEMON
	[ "$?" = 2 ] && return 2
	RETVAL="$?"
	# Many daemons don't delete their pidfiles when they exit.
	rm -f $PIDFILE
	return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
	#
	# If the daemon can reload its configuration without
	# restarting (for example, when it is sent a SIGHUP),
	# then implement that here.
	#
	start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
	return 0
}

case "$1" in
  start)
	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
	do_start
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  stop)
	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
	do_stop
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  restart|force-reload)
	#
	# If the "reload" option is implemented then remove the
	# 'force-reload' alias
	#
	log_daemon_msg "Restarting $DESC" "$NAME"
	do_stop
	case "$?" in
	  0|1)
		do_start
		case "$?" in
			0) log_end_msg 0 ;;
			1) log_end_msg 1 ;; # Old process is still running
			*) log_end_msg 1 ;; # Failed to start
		esac
		;;
	  *)
	  	# Failed to stop
		log_end_msg 1
		;;
	esac
	;;
  *)
	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
	echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
	exit 3
	;;
esac

:

/etc/default/jenkins-slave

# defaults for jenkins continuous integration slave.

# usually set to host name.
JENKINS_SLAVE_NAME=`hostname`

# slave admin must provide this.
JENKINS_SLAVE_USER=

# usually the home of the local slave user.
JENKINS_SLAVE_HOME=

# slave admin must set which host to connect to.
JENKINS_MASTER_LOCATION="ci.solvcon.net"

# slave admin doesn't need to change these.
JENKINS_SLAVE_ROOT="$JENKINS_SLAVE_HOME/$JENKINS_SLAVE_NAME"
JENKINS_SLAVE_JAR="$JENKINS_SLAVE_ROOT/slave.jar"
JENKINS_SLAVE_LOG="$JENKINS_SLAVE_ROOT/slave.log"
JENKINS_SLAVE_JAR_URL="http://$JENKINS_MASTER_LOCATION/jnlpJars/slave.jar"
JENKINS_NODE_URL="http://$JENKINS_MASTER_LOCATION/computer/$JENKINS_SLAVE_NAME/slave-agent.jnlp"

Table Of Contents

This Page